/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20160422-64(RM)
 * Copyright (c) 2000 - 2016 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-12.aml, Sun Jan 15 01:33:32 2017
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000005AC (1452)
 *     Revision         0x02
 *     Checksum         0x11
 *     OEM ID           "ACRSYS"
 *     OEM Table ID     "ACRPRDCT"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "1025"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 2, "ACRSYS", "ACRPRDCT", 0x00001000)
{
    /*
     * iASL Warning: There were 3 external control methods found during
     * disassembly, but only 1 was resolved (2 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.IFFS.FFSS, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.GFX0.ASLC, FieldUnitObj)
    External (_SB_.PCI0.GFX0.ASLE, FieldUnitObj)
    External (_SB_.PCI0.GFX0.PARD, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.GFX0.STAT, FieldUnitObj)
    External (_SB_.PCI0.GFX0.TCHE, FieldUnitObj)
    External (_SB_.PCI0.LPCB.H_EC.ECAV, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.LPCB.H_EC.ECMD, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.PCI0.LPCB.H_EC.ECRD, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.LPCB.H_EC.ECWT, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (_SB_.PCI0.LPCB.H_EC.IBT1, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.LPCB.H_EC.IBT2, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.LPCB.H_EC.LSTE, UnknownObj)    // Warning: Unknown object
    External (_SB_.PCI0.LPCB.H_EC.WTMS, UnknownObj)    // Warning: Unknown object
    External (ICNF, FieldUnitObj)

    Scope (\_SB)
    {
        Device (IAOE)
        {
            OperationRegion (ISCT, SystemMemory, 0x98EBEE18, 0x000D)
            Field (ISCT, AnyAcc, Lock, Preserve)
            {
                WKRS,   8, 
                ISEF,   8, 
                FFSE,   8, 
                ITMR,   8, 
                ECTM,   32, 
                RCTM,   32, 
                ATOW,   8
            }

            Name (_HID, "INT33A0")  // _HID: Hardware ID
            Name (_CID, "PNP0C02")  // _CID: Compatible ID
            Name (_UID, Zero)  // _UID: Unique ID
            Name (IBT1, Zero)
            Name (IBT2, Zero)
            Name (INSB, Zero)
            Name (IMDS, Zero)
            Name (IWDT, Zero)
            Method (GABS, 0, NotSerialized)
            {
                Return (ICNF)
            }

            Method (GAOS, 0, NotSerialized)
            {
                Return (Or (And (IBT1, One), And (IMDS, 0x06)))
            }

            Method (SAOS, 1, NotSerialized)
            {
                If (And (\_SB.PCI0.GFX0.TCHE, 0x0100))
                {
                    If (LAnd (LAnd (And (IBT1, One), LNot (And (Arg0, One))), And (\_SB.IAOE.WKRS, 0x10)))
                    {
                        If (LNot (\_SB.PCI0.GFX0.PARD ()))
                        {
                            Store (And (\_SB.PCI0.GFX0.STAT, 0xFFFFFFFFFFFFFFFC), \_SB.PCI0.GFX0.STAT)
                            Store (Or (\_SB.PCI0.GFX0.ASLC, 0x0100), \_SB.PCI0.GFX0.ASLC)
                            Store (One, \_SB.PCI0.GFX0.ASLE)
                        }
                    }
                }

                Store (And (Arg0, 0x06), IMDS)
                Or (And (IBT1, 0xFE), And (Arg0, One), IBT1)
                If (LEqual (ITMR, Zero))
                {
                    \_SB.PCI0.LPCB.H_EC.ECWT (IBT1, RefOf (\_SB.PCI0.LPCB.H_EC.IBT1))
                    \_SB.PCI0.LPCB.H_EC.ECMD (0x2B)
                }
            }

            Method (GANS, 0, NotSerialized)
            {
                Return (INSB)
            }

            Method (SANS, 1, NotSerialized)
            {
                Store (And (Arg0, One), INSB)
            }

            Method (GWLS, 0, NotSerialized)
            {
                Store (Zero, Local0)
                And (IBT1, 0x0E, Local0)
                Return (Local0)
            }

            Method (SWLS, 1, NotSerialized)
            {
                Or (And (IBT1, 0xF1), And (Arg0, 0x0E), IBT1)
                If (LAnd (LEqual (ITMR, Zero), \_SB.PCI0.LPCB.H_EC.ECAV))
                {
                    Or (And (\_SB.PCI0.LPCB.H_EC.ECRD, RefOf (\_SB.PCI0.LPCB.H_EC.IBT1), 0xF1), Zero, And (Arg0, 0x0E))
                    Local0
                    If (CondRefOf (\_SB.IFFS.FFSS))
                    {
                        If (LAnd (And (\_SB.IFFS.FFSS, 0x03), And (Arg0, 0x02)))
                        {
                            Or (Local0, 0x04, Local0)
                        }
                    }

                    \_SB.PCI0.LPCB.H_EC.ECWT (Local0, RefOf (\_SB.PCI0.LPCB.H_EC.IBT1))
                    \_SB.PCI0.LPCB.H_EC.ECMD (0x2B)
                }
            }

            Method (GWWS, 0, NotSerialized)
            {
                ShiftRight (And (IBT1, 0x70), 0x03, Local0)
                If (LAnd (LEqual (ITMR, Zero), \_SB.PCI0.LPCB.H_EC.ECAV))
                {
                    Or (Local0, ShiftRight (Or (\_SB.PCI0.LPCB.H_EC.ECRD, RefOf (\_SB.PCI0.LPCB.H_EC.IBT2), 0x02), Zero, One))
                    Local0
                }

                Return (Local0)
            }

            Method (SWWS, 1, NotSerialized)
            {
                Or (And (IBT1, 0x8F), ShiftLeft (And (Arg0, 0x0E), 0x03), IBT1)
                If (LAnd (LEqual (ITMR, Zero), \_SB.PCI0.LPCB.H_EC.ECAV))
                {
                    Or (And (\_SB.PCI0.LPCB.H_EC.ECRD, RefOf (\_SB.PCI0.LPCB.H_EC.IBT1), 0x8F), Zero, ShiftLeft (And (Arg0, 0x0E), 0x03))
                    Local0
                    If (CondRefOf (\_SB.IFFS.FFSS))
                    {
                        If (LAnd (And (\_SB.IFFS.FFSS, 0x03), And (Arg0, 0x02)))
                        {
                            Or (Local0, 0x20, Local0)
                        }
                    }

                    \_SB.PCI0.LPCB.H_EC.ECWT (Local0, RefOf (\_SB.PCI0.LPCB.H_EC.IBT1))
                    \_SB.PCI0.LPCB.H_EC.ECMD (0x2B)
                }
            }

            Method (SASD, 1, Serialized)
            {
                If (LAnd (And (ICNF, 0x10), LGreater (Arg0, Zero)))
                {
                    If (LEqual (ITMR, One))
                    {
                        Store (Arg0, RCTM)
                    }
                    Else
                    {
                        Store (Arg0, ECTM)
                    }
                }
                ElseIf (LEqual (ITMR, One))
                {
                    Store (Zero, RCTM)
                }
                Else
                {
                    Store (Zero, ECTM)
                    \_SB.PCI0.LPCB.H_EC.ECWT (Zero, RefOf (\_SB.PCI0.LPCB.H_EC.WTMS))
                }
            }

            Method (GPWR, 0, NotSerialized)
            {
                If (And (WKRS, 0x2F))
                {
                    Return (And (WKRS, 0x2F))
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (GPCS, 0, NotSerialized)
            {
                If (LAnd (LEqual (ITMR, Zero), \_SB.PCI0.LPCB.H_EC.ECAV))
                {
                    Return (And (\_SB.PCI0.LPCB.H_EC.ECRD, RefOf (\_SB.PCI0.LPCB.H_EC.LSTE), One))
                    Zero
                }
                Else
                {
                    Return (One)
                }
            }

            Method (GAWD, 0, NotSerialized)
            {
                Return (IWDT)
            }

            Method (SAWD, 1, NotSerialized)
            {
                Store (Arg0, IWDT)
            }
        }
    }
}

